<template src="./infoComponent.htm"></template>

<script>

    import VueTagsInput from '@johmun/vue-tags-input';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    export default {

        data() {

            return {

                lastInsertedTag: '',

                baseInfo: {

                    name: '',

                    values: []
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        components: { VueTagsInput },

        methods: {
            
            /**
             * @param attribute
             */
            createAttributeStoreObject(attribute) {

                return {

                    name: attribute.name,

                    values: attribute.values.length > 0 ? attribute.values.map( (el) => el.text.toLowerCase()) : []
                }
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setAttribute', this.createAttributeStoreObject(newBaseInfo));
                },

                deep: true
            }
        }
    }

</script>